//+------------------------------------------------------------------+
//|                                          Goldminer1Histogram.mq4 |
//|                                             Copyright  2010, Me |
//| Plot the Goldminer1 in continuous +1 (up) or -1 (Down) histogram |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Me"
#property link      "http://www...com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Magenta
#property indicator_color2 Yellow

//---- input parameters
extern int RISK = 4;
extern int VerifyShift = 1;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_HISTOGRAM);
//   SetIndexArrow(0,234);
   SetIndexBuffer(0,ExtMapBuffer1); 
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_HISTOGRAM);
//   SetIndexArrow(1,233);
   SetIndexBuffer(1,ExtMapBuffer2); 
   SetIndexEmptyValue(1,0.0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
   {
   int      i,j,counted_bars=IndicatorCounted();
   int      limit;
   
   double   price, current_value;
   int      position, current_position;

//----
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
   limit=Bars-counted_bars;

   for(i=limit; i>=0; i--)
      {
      // Goldminer provides only the peak & trough values to draw the arrows.
      // Goldminer only returns the price change. Bars in between are zeros.
      double gm1p = iCustom(0,0,"goldminer1",RISK,Bars,0,i+VerifyShift);
      double gm2y = iCustom(0,0,"goldminer1",RISK,Bars,1,i+VerifyShift);
      if(gm1p>gm2y){ExtMapBuffer1[i] = gm1p;}
      else {ExtMapBuffer1[i] = gm2y;}
//      ExtMapBuffer1[i] = iCustom(0,0,"goldminer1",RISK,Bars,0,i+VerifyShift);
//      ExtMapBuffer2[i] = iCustom(0,0,"goldminer1",RISK,Bars,1,i+VerifyShift);
      if (ExtMapBuffer1[i] != 0)           // dump into a new value
         {                                // remember it.
         if(ExtMapBuffer1[i+1] > ExtMapBuffer1[i]){
         price = ExtMapBuffer2[i]*2;}
         else{
         price = ExtMapBuffer1[i]*2;}
         }
      if (ExtMapBuffer2[i] ==0)            // new cell with Zeros, fill in the prices
         ExtMapBuffer1[i] = price;
//      if (ExtMapBuffer2[i] ==0)            // new cell with Zeros, fill in the prices
//         ExtMapBuffer2[i] = price;
      WindowRedraw();
      }

   for(j=limit; j>=0; j--)
      {
      // Goldminer provides only the peak & trough values to draw the arrows.
      // Goldminer only returns the price change. Bars in between are zeros.
      double gm1pj = iCustom(0,0,"goldminer1",RISK,Bars,0,j+VerifyShift);
      double gm2yj = iCustom(0,0,"goldminer1",RISK,Bars,1,j+VerifyShift);
      if(gm1p>gm2y){ExtMapBuffer2[j] = gm1pj;}
      else {ExtMapBuffer2[j] = gm2yj;}
//      ExtMapBuffer2[j] = iCustom(0,0,"goldminer1",RISK,Bars,0,i+VerifyShift);
//      ExtMapBuffer1[j] = iCustom(0,0,"goldminer1",RISK,Bars,1,i+VerifyShift);
      if (ExtMapBuffer2[j] != 0)           // dump into a new value
         {                                // remember it.
         if(ExtMapBuffer2[j+1] > ExtMapBuffer2[j]){
         price = ExtMapBuffer1[j]*2;}
         else{
         price = ExtMapBuffer2[j]*2;}
         }
      if (ExtMapBuffer1[j] ==0)            // new cell with Zeros, fill in the prices
         ExtMapBuffer2[j] = price;
//      if (ExtMapBuffer1[j] ==0)            // new cell with Zeros, fill in the prices
//         ExtMapBuffer1[j] = price;
      WindowRedraw();
      }


   return(0);
   }

